

//these header files are to be included in the main program
#include<stdio.h>
#include<string.h>
#include<iostream>
#include<cmath>
#define scale 0.0001
#define limit 5000   //some random appropriate limit
#define resolution 0.0001//accuracy in result is one decimal point less than resolution
#define size 100//defines the size of arrays in which local max and min are stored
using namespace std;

//declaration of global variables
char stack[50];                  //used in infx to pstfx conversion
char infx[50];                   //used to store the infx string formed frm input
char pstfx[50];                  //used to store pstfx string formed frm infx
float values[10]={};             //used to store constants present in the inpt string
float eval[10];                  //stack used in evaluation
int top1=-1;                      //index indicator of the char stack
int top2=-1;                      //index indicator of the float stack named eval
int flag2=0;			  //it is incremented when the expression is not defined


//the evaluate wriiten below is just for checking


//this evaluate rounds the x coordinates of the critical points to two decimal places
//declaration of functions
void inpt_to_infx(char input[]); 
void in_to_post(char infix[]);   
void ch_push (char);                
void fl_push(float);                  
float fl_pop();                     
char ch_pop();                      
float evaluate(float x);        
   
float round(float x){
      float a;
      int rem;
      x=(int)(x/0.001);
      rem=(int)x%10;
      x=(int)x/10;
      if(rem>5){
                x++;
                }
      
      x=x*0.01;
      return x;
}

//this evaluate computes the derivative at a point      
float derivative(float a,float h){
      float der;
      der= (evaluate(a+h)-evaluate(a))/h;
      return der;
      }


/*this fuction scans the given range for critical points, the points thus found 
are stored in a two dimensional array called opt[2][size]. The 1st row of the
array opt stores first size no. of local maxima encountered and the 2nd row
stores the first size no. of local minima encountered. If more maxima or minima
points are to be analysed then the value of size is to be increased. The
evaluate returns the pointer to the element opt[0][0] using which two separate
arrays called max[size] and min[size] are generated in the main program.
The zeroth element of both these arrays contains the number of maxima/minima 
points in the specified range and the first elements contain the x coordinate of
the point where there exists a global maxima/minima in the given range   */ 
float *optima(float a, float b){
      float h;//h is the change in x over which derivative is calculated
      h=(b-a)*resolution;
      float d1,d2;
      //variable d1 and d2 store the derivatives at a point c and c+h respectively
      float opt[size][size];//array to store the values
      opt[0][0]=0;
      opt[1][0]=0;
      int i,j=1,k=1;//i keeps track of the iteration form a to b
      //ja nd k store the no. of maxima and minima respectively
      float pre,post;//pre and post store the values of derivatives at two 
      //successive points
      pre=derivative(a,h);
      for(i=1;(a+i*h)<b;i++){//iteration runs from a to b
              post=derivative(a+i*h,h);
              if(pre*post<0){//this condition means the derivative ha sa root in between
                              if(pre>0){//implies local maxima
                                        opt[0][j]=round(a+i*h);
                                        j++;
                                        }
                              else if(pre<0){//implies local minima
                                   opt[1][k]=round(a+i*h);
                                   k++;
                                   }
                              }
              pre=post;
              }
      opt[0][0]=j-1;
      opt[1][0]=k-1;
      //the global maxima and minima are calculated below and are stored in the
      //columns
      float gmax,gmin,swap;
      int jmax=1,kmin=1;
      if(j>1){
              gmax=evaluate(opt[0][1]);
              for(i=2;i<j+1;i++){
                               if(evaluate(opt[0][i])>gmax){
                                                         gmax=evaluate(opt[0][i]);
                                                         jmax=i;
                                                         }
                               }
              swap=opt[0][1];
              opt[0][1]=opt[0][jmax];
              opt[0][jmax]=swap;
              }
      if(k>1){
              gmin=evaluate(opt[1][1]);
              for(i=2;i<k+1;i++){
                               if(evaluate(opt[1][i])<gmin){
                                                       gmin=evaluate(opt[1][i]);
                                                       kmin=i;
                                                       }
                               }
              swap=opt[1][1];
              opt[1][1]=opt[1][kmin];
              opt[1][kmin]=swap;
              }
      return opt[0];//returning the pointer to the opt[0][0] element
}
      
      
//evaluate to compute double derivative at a point whose x coordinate is c
//actually this evaluate should also check for nonexistence of
//double derivative but since it is not exactly known how do display this 
//error it is not done here.This evaluate requires to be modified later
float d_der(float c,float h){//h=(b-a)*resolution and should be given as input
            float val;
            val=(derivative((c+h),h)-derivative(c,h))/h;
            return val;
            }
float area(float min,float max)   //third parameter defines the function whose area to be calculated.
{
   float sum=0;float i;
   
   
   for(i=0.0;i+min<=max;i+=scale)
   { 
      if(evaluate(i+min)>=limit||evaluate(i+min)<=-limit)     //if atleast one of them go beyond the limit,its assumed to be non integrable
      {
        flag2++;
	return 0;
      }
      else
      {
         sum+=evaluate(i+min)*scale;
      }
   }
   return round(sum);
}                   
            



//function to convert inpt to infx
//all the no are stored in an array & are replaced by their corresponding array index 
void inpt_to_infx(char input[]){
     int i,j=0,k=0;                //i,j & k keep track of input, infx and values respectively
     float digit,value,m=1;
     for(i=0;input[i]!='\0';){
                              if(input[i]>=48 && input[i]<=57){//checks if input is a digit indicating a constant
                                                 infx[j]=(char)(k+48);
                                                 j++;                   
                                                 while(input[i]>=48 && input[i]<=57){
                                                                  values[k]=values[k]*10+input[i]-48;
                                                                  i++;
                                                                  }
                                                k++;
                                                }
                                 else if(input[i]==46){//checks for a decimal point
                                                  if(input[i-1]>=48 && input[i-1]<=57){k--;j--;}
                                                  infx[j]=(char) (k+48);
                                                  j++;     
                                                  i++;
                                                  while(input[i]>=48 && input[i]<=57){
                                                                    value=pow(10,m);
                                                                    digit=(float)(input[i]-48); 
                                                                    values[k]=values[k]+digit/value;
                                                                    m++;
                                                                    i++;
                                                                    }
                                                  k++;
                                                  }
                                 else if(input[i]>=97 && input[i]<=122 && input[i-1]>=48 && input[i-1]<=57){
                                      infx[j]='*';
                                      j++;
                                      infx[j]=input[i];
                                      j++;
                                      i++;
                                      }
                                 else if(input[i]==45 && !((input[i-1]>=48 && input[i-1]<=57)||input[i-1]==120||input[i-1]==41)){
                                      values[k]=(-1);
                                      infx[j]=(char)(k+48);j++;
                                      infx[j]='*';j++;
                                      k++;
                                      i++;
                                      }
                                 else{
                                      infx[j]=input[i];
                                      j++;
                                      i++;
                                      }
                              }
     infx[j]='\0';
     }
//function to push a character in char stack
void ch_push (char symb)            //function to push an operator into the top of the stack
{
		if (top1>=49)         //top1 is the topmost index of stack which is filled
	{
		printf("stack overflow");
		getchar();
		return;
	}
	else
	{
		top1=top1+1;            //ch_push symbol into the next empty position
		stack[top1]=symb;
	}
}
//function to push a number in float stack
void fl_push(float x)            //function to push an operator into the top of the stack
{
	if (top2>=49)         //top2 is the topmost index of stack which is filled
	{
		printf("stack overflow");
		getchar();
		return;
	}
	else
	{
		top2=top2+1;            //ch_push symbol into the next empty position
		eval[top2]=x;
	}
}
//function to ch_pop a character from char stack
char ch_pop()                                       //function to ch_pop out an operator out from the top of the stack
{
	char item;
	if(top1==-1)                             //stack contains symbols from index=0
	{
		printf("stack empty");
		getchar();
		return(0);
	}
	else
	{
	 	item=stack[top1];                //ch_pop out topmost element
		top1--;
	}
	return(item);
}
 //function to pop a number from float stack
float fl_pop()                              //function to ch_pop out an operator out from the top of the stack
{
	float var;
	if(top2==-1)                         //stack contains symbols from index=0
	{
		printf("stack empty");
		getchar();
		return(0);
	}
	else
	{
	 	var=eval[top2];                //ch_pop out topmost element
		top2--;
	}
	return(var);
}

//define precedence order for various operators using ASCII codes
int preced(char ch)
{
    if(ch==115 || ch==99 || ch==116 || ch==105 || ch==111 || ch==97 || ch==110 || ch==108 || ch==101)
    {
        return(7);
    }                                                                     
	else if(ch==94)                         //ASCII code for ^
	{
		return(6);
	}
	else if(ch==47)                         //ASCII code for /
	{
		return(5);
	}
	else
	if(ch==42)                              //ASCII code for *
	{
		return(4);
	}
	else if(ch==45)                         //ASCII code for -
	{
		return(3);	
	}
	else if(ch==43)                        //ASCII code for +
		return(2);
 	else
		return(1);                         //any other character receives least precedence
}
//function to convert infx to pstfx
/*Infix to Postfix Conversion :

In normal algebra we use the infix notation like a+b*c. The corresponding postfix notation is abc*+. The algorithm for the conversion is as follows :

    * Scan the Infix string from left to right.
    * Initialise an empty stack.
    * If the scannned character is an operand, add it to the Postfix string. If the scanned character is an operator and if the stack is empty Push the character to stack.
          o If the scanned character is an Operand and the stack is not empty, compare the precedence of the character with the element on top of the stack (topStack). If topStack has higher precedence over the scanned character Pop the stack else Push the scanned character to stack. Repeat this step as long as stack is not empty and topStack has precedence over the character.
      Repeat this step till all the characters are scanned.
    * (After all characters are scanned, we have to add any character that the stack may have to the Postfix string.) If stack is not empty add topStack to Postfix string and Pop the stack. Repeat this step as long as stack is not empty.
    * Return the Postfix string. */

/*takes an infix expression and converts it into an equivalent postfix expression*/

void in_to_post(char infix[])
{
	int length;
	static int index=0,pos=0;         
	char symbol,temp;
	length=strlen(infix);
	ch_push('#');                            //use # as sentry
	while(index<length)
	{
		symbol=infix[index];
		switch(symbol)
		{
			case'(':ch_push(symbol);         // directly ch_push '(' to top of stack
			break;
			case')' :temp=ch_pop();          // ch_pop out all symbols between '(' and ')' 
			while(temp!='(')
			{
				pstfx[pos]=temp;
				pos++;
				temp=ch_pop();
			}
			break;
			case '+' :
			case '-' :
			case '*' :
			case '/' :
			case '^' :
            		case 's' :           //symbol for sin
            		case 'c' :           //symbol for cos
			case 't' :           //symbol for tan
            		case 'i' :           //symbol for cosec
            		case 'o' :           //symbol for sec
            		case 'a' :           //symbol for cot
            		case 'n' :           //symbol for ln
            		case 'l' :           //symbol for log
            		case 'e' :           //symbol for exponential
            			while (preced(stack[top1])>=preced(symbol))         //ch_push or ch_pop symbols depending on preference order
				{
					temp=ch_pop();
					pstfx[pos]=temp;
					pos++;
				}
				ch_push(symbol);
				break;
                        //array index no			
			case '0' :          
            		case '1' :      
            		case '2' :        
            		case '3' :        
            		case '4' :        
            		case '5' :        
            		case '6' :        
            		case '7' :        
            		case '8' :        
            		case '9' :
            		case 'x' :
            		case '\0':       
            			pstfx[pos++]=symbol;          //in case of non operators,add the operand to the postfix string
				break;
			default:cout<<"\n\nERROR\n\n";
				break;
		}
		index++;
	}
	//ch_pop out the remaining symbols and add them to the postfix string
	while(top1>0)
	{
		temp=ch_pop();
		pstfx[pos++]=temp;
	}
	pstfx[pos++]='\0';
}
//function to evaluate the postfix expression 
/*In normal algebra we use the infix notation like a+b*c. The corresponding postfix notation is abc*+. The algorithm for the conversion is as follows :

    * Scan the Postfix string from left to right.
    * Initialise an empty stack.
    * If the scannned character is an operand, add it to the stack. If the scanned character is an operator, there will be atleast two operands in the stack.
          o If the scanned character is an Operator, then we store the top most element of the stack(topStack) in a variable temp. Pop the stack. Now evaluate topStack(Operator)temp. Let the result of this operation be retVal. Pop the stack and Push retVal into the stack.
      Repeat this step till all the characters are scanned.
    * After all characters are scanned, we will have only one element in the stack. Return topStack.*/ 
float evaluate(float x){
      float f1,f2,f3,result;
      int z;
      for(int i=0;pstfx[i]!='\0';i++){
              switch (pstfx[i]){
                     case '0' :
                     case '1' :
                     case '2' :
                     case '3' :
                     case '4' :
                     case '5' :
                     case '6' :
                     case '7' :
                     case '8' :
                     case '9' :
                          z=(int)pstfx[i]-48;
                          f1=values[z];
                          fl_push(f1);
                          break;
                     case 'x' :
                          fl_push(x);
                          break;
                     case '+':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=f1+f2;
                          fl_push(f3);
                          break;
                     case '-':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=f1-f2;
                          fl_push(f3);
                          break;
                     case '*':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=f1*f2;
                          fl_push(f3);
                          break;
                     case '/':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=f1/f2;
                          fl_push(f3);
                          break;
                     case '^':
                          f2=fl_pop();
                          f1=fl_pop();
                          f3=pow(f1,f2);
                          fl_push(f3);
                          break;
                     case 's':
                          f1=fl_pop();
                          f2=sin(f1);
                          fl_push(f2);
                          break;
                     case 'c':
                          f1=fl_pop();
                          f2=cos(f1);
                          fl_push(f2);
                          break;
                     case 't':
                          f1=fl_pop();
                          f2=tan(f1);
                          fl_push(f2);
                          break;
                     case 'i':
                          f1=fl_pop();
                          f2=1/sin(f1);
                          fl_push(f2);
                          break;
                     case 'o':
                          f1=fl_pop();
                          f2=1/cos(f1);
                          fl_push(f2);
                          break;
                     case 'a':
                          f1=fl_pop();
                          f2=1/tan(f1);
                          fl_push(f2);
                          break;
                     case 'n':
                          f1=fl_pop();
			  f2=log(f1);
                          fl_push(f2);
                          break;
                     case 'l':
                          f1=fl_pop();
                          f2=log10(f1);
                          fl_push(f2);
                          break;
                     case 'e':
                          f1=fl_pop();
                          f2=exp(f1);
                          fl_push(f2);
                          break;
                     default :cout<<"\nERROR\n";
                     }
              }
              result=fl_pop();
	      if(result<500000 && result>(-500000)){
              				return result;
						}
	      else{
			flag2++;		
			return NULL;
			}      
	}
int main()
{
	char inpt[50];               //used to store the function entered as a string
    float x,y,z;
	printf("Enter the infix expression");
	gets(inpt);
    inpt_to_infx(inpt);
                                 
	in_to_post(infx);
	
	cin>>x;
	z=round(derivative(x,0.00001));
	cout<<"\nthe value is"<<z;
          float *p;
          float a,b;
          float max[size],min[size];//local max and min are stored in these arrays
          p=optima(0,3);//the value of a and b are to be asked from the user
          //here they are assumed  to be asked earlier
          //storing the local max and min in the respective array
          for(int i=0;i<size;i++){
                  max[i]=*p;
                  p++;
                  }
          for(int i=0;i<size;i++){
                  min[i]=*p;
                  p++;
                  }
	//for(int i=0;i<=max[0];i++){cout<<"\t"<<max[i]<<endl;}
	//for(int i=0;i<=min[0];i++){cout<<"\t"<<min[i]<<endl;}
        cin>>a;
        return 0;
}
