#include <assert.h>
#include "bitmap.h"

// Define  window
SimpleWindow W("Graphplotter", 25.0, 15.0, Position(1.0, 1.0));

//Defining the BitMap
BitMap GiveF(W);
BitMap PlotG(W);
BitMap DrawT(W);
BitMap DrawN(W);
/*Defining the callback for the mouseclick*/


int MouseClickEvent(const Position &MousePosition){
	if(GiveF.IsInside(MousePosition)){
		//function should be called for taking input 
	}
	if(PlotG.IsInside(MousePosition)){
		//function should be called for plotting graph 
	}
	if(DrawT.IsInside(MousePosition)){
		//function should be called for drawing tangent at a point
	}
	if(DrawN.IsInside(MousePosition)){
		//function should be called for drawing normal at a point
	}
	return 1;

}



int ApiMain(){
// Open the window
/*Drawing a demarcation between the graph area and the interface and also drawing the coordinate axes with an arrow at the ends*/


	W.Open();
	assert(W.GetStatus() == WindowOpen);
	W.RenderLine(Position(15.0,0),Position(15.0,15.0),Black,0.01);
	W.RenderLine(Position(15.1,0),Position(15.1,15.0),Black,0.01);
	W.RenderText(Position(4.0,0.2),Position(11.0,1.5),"Your Graph",Blue);
	W.RenderLine(Position(7.5,1.5),Position(7.5,14.5),Black,0.01);
	W.RenderLine(Position(0.5,7.5),Position(14.5,7.5),Black,0.01);
	W.RenderText(Position(7.5,1.5),Position(9.5,2),"Y axis",Black);
	W.RenderText(Position(13,6.5),Position(15,7.5),"X axis",Black);
	W.RenderLine(Position(14.5,7.3),Position(14.8,7.5),Black,0.01);
	W.RenderLine(Position(14.5,7.7),Position(14.8,7.5),Black,0.01);
	W.RenderLine(Position(14.5,7.7),Position(14.5,7.3),Black,0.01);
	W.RenderLine(Position(7.3,1.5),Position(7.7,1.5),Black,0.01);
	W.RenderLine(Position(7.3,1.5),Position(7.5,1.3),Black,0.01);
	W.RenderLine(Position(7.7,1.5),Position(7.5,1.3),Black,0.01);
	W.RenderLine(Position(0.5,7.3),Position(0.3,7.5),Black,0.01);
	W.RenderLine(Position(0.5,7.7),Position(0.3,7.5),Black,0.01);
	W.RenderLine(Position(0.5,7.7),Position(0.5,7.3),Black,0.01);
	W.RenderLine(Position(7.3,14.5),Position(7.7,14.5),Black,0.01);
	W.RenderLine(Position(7.3,14.5),Position(7.5,14.7),Black,0.01);
	W.RenderLine(Position(7.7,14.5),Position(7.5,14.7),Black,0.01);
/*Displayig the options available to the user */

	W.RenderText(Position(17,0.5),Position(20,1),"Give the function to be plotted",Blue);
	W.RenderText(Position(17,1),Position(20,1.5),"by clicking the GIVE FCN button",Blue);
	GiveF.Load("GiveF.XPM");
	assert(GiveF.GetStatus() == BitMapOkay);
	GiveF.SetPosition(Position(20,1));
	GiveF.Draw();

	W.RenderText(Position(17,3),Position(20,3.5),"Click the PLOT Button to plot ",Blue);
	W.RenderText(Position(17,3.5),Position(20,4),"graph of the given Function",Blue);
	PlotG.Load("PlotG.XPM");
	assert(PlotG.GetStatus() == BitMapOkay);
	PlotG.SetPosition(Position(20,3));
	PlotG.Draw();

	W.RenderText(Position(17,5.5),Position(20,6),"Click the TANGENT Button to",Blue);
	W.RenderText(Position(17,6),Position(20,6.5),"draw tangent at a point",Blue);
	DrawT.Load("DrawT.XPM");
	assert(DrawT.GetStatus() == BitMapOkay);
	DrawT.SetPosition(Position(20,5.5));
	DrawT.Draw();

	W.RenderText(Position(17,8),Position(20,8.5),"Click the NORMAL Button to",Blue);
	W.RenderText(Position(17,8.5),Position(20,9),"draw normal at a point",Blue);
	DrawT.Load("DrawN.XPM");
	assert(DrawN.GetStatus() == BitMapOkay);
	DrawN.SetPosition(Position(20,5.5));
	DrawN.Draw();






	return 0;
}
